*** a/src/backend/parser/parse_agg.c
--- b/src/backend/parser/parse_agg.c
***************
*** 44,50 **** typedef struct
  	int			sublevels_up;
  } check_ungrouped_columns_context;
  
! static int	check_agg_arguments(ParseState *pstate, List *args, Expr *filter);
  static bool check_agg_arguments_walker(Node *node,
  						   check_agg_arguments_context *context);
  static void check_ungrouped_columns(Node *node, ParseState *pstate, Query *qry,
--- 44,50 ----
  	int			sublevels_up;
  } check_ungrouped_columns_context;
  
! static int	check_agg_arguments(ParseState *pstate, List *args, List *agg_ordset, Expr *filter);
  static bool check_agg_arguments_walker(Node *node,
  						   check_agg_arguments_context *context);
  static void check_ungrouped_columns(Node *node, ParseState *pstate, Query *qry,
***************
*** 75,81 **** static bool check_ungrouped_columns_walker(Node *node,
   */
  void
  transformAggregateCall(ParseState *pstate, Aggref *agg,
! 					   List *args, List *aggorder, bool agg_distinct)
  {
  	List	   *tlist;
  	List	   *torder;
--- 75,81 ----
   */
  void
  transformAggregateCall(ParseState *pstate, Aggref *agg,
! 					   List *args, List *aggorder, bool agg_distinct, bool agg_within_group)
  {
  	List	   *tlist;
  	List	   *torder;
***************
*** 93,104 **** transformAggregateCall(ParseState *pstate, Aggref *agg,
  	 */
  	tlist = NIL;
  	attno = 1;
! 	foreach(lc, args)
  	{
! 		Expr	   *arg = (Expr *) lfirst(lc);
! 		TargetEntry *tle = makeTargetEntry(arg, attno++, NULL, false);
  
! 		tlist = lappend(tlist, tle);
  	}
  
  	/*
--- 93,116 ----
  	 */
  	tlist = NIL;
  	attno = 1;
! 
! 	if (agg_within_group)
! 	{
! 		agg->isordset = TRUE;
! 		agg->orddirectargs = args;
! 	}
! 	else
  	{
! 		foreach(lc, args)
! 		{
! 			Expr	   *arg = (Expr *) lfirst(lc);
! 			TargetEntry *tle = makeTargetEntry(arg, attno++, NULL, false);
  
! 			tlist = lappend(tlist, tle);
! 		}
! 
! 		agg->isordset = FALSE;
! 		agg->orddirectargs = NIL;
  	}
  
  	/*
***************
*** 160,166 **** transformAggregateCall(ParseState *pstate, Aggref *agg,
  	 * Check the arguments to compute the aggregate's level and detect
  	 * improper nesting.
  	 */
! 	min_varlevel = check_agg_arguments(pstate, agg->args, agg->aggfilter);
  	agg->agglevelsup = min_varlevel;
  
  	/* Mark the correct pstate level as having aggregates */
--- 172,178 ----
  	 * Check the arguments to compute the aggregate's level and detect
  	 * improper nesting.
  	 */
! 	min_varlevel = check_agg_arguments(pstate, agg->args, agg->orddirectargs, agg->aggfilter);
  	agg->agglevelsup = min_varlevel;
  
  	/* Mark the correct pstate level as having aggregates */
***************
*** 312,318 **** transformAggregateCall(ParseState *pstate, Aggref *agg,
   * which we can't know until we finish scanning the arguments.
   */
  static int
! check_agg_arguments(ParseState *pstate, List *args, Expr *filter)
  {
  	int			agglevel;
  	check_agg_arguments_context context;
--- 324,330 ----
   * which we can't know until we finish scanning the arguments.
   */
  static int
! check_agg_arguments(ParseState *pstate, List *args, List *agg_ordset, Expr *filter)
  {
  	int			agglevel;
  	check_agg_arguments_context context;
***************
*** 330,335 **** check_agg_arguments(ParseState *pstate, List *args, Expr *filter)
--- 342,350 ----
  								  check_agg_arguments_walker,
  								  (void *) &context);
  
+ 	(void) expression_tree_walker((Node *) agg_ordset,	  check_agg_arguments_walker,
+ 								  (void *) &context);
+ 
  	/*
  	 * If we found no vars nor aggs at all, it's a level-zero aggregate;
  	 * otherwise, its level is the minimum of vars or aggs.
***************
*** 353,360 **** check_agg_arguments(ParseState *pstate, List *args, Expr *filter)
  				(errcode(ERRCODE_GROUPING_ERROR),
  				 errmsg("aggregate function calls cannot be nested"),
  				 parser_errposition(pstate,
! 									locate_agg_of_level((Node *) args,
! 														agglevel))));
  
  	return agglevel;
  }
--- 368,375 ----
  				(errcode(ERRCODE_GROUPING_ERROR),
  				 errmsg("aggregate function calls cannot be nested"),
  				 parser_errposition(pstate,
! 								locate_agg_of_level((Node *) args,
! 								agglevel))));
  
  	return agglevel;
  }
***************
*** 823,830 **** check_ungrouped_columns_walker(Node *node,
  	 * We do need to look at aggregates of lower levels, however.
  	 */
  	if (IsA(node, Aggref) &&
! 		(int) ((Aggref *) node)->agglevelsup >= context->sublevels_up)
  		return false;
  
  	/*
  	 * If we have any GROUP BY items that are not simple Vars, check to see if
--- 838,852 ----
  	 * We do need to look at aggregates of lower levels, however.
  	 */
  	if (IsA(node, Aggref) &&
! 		(int) ((Aggref *) node)->agglevelsup > context->sublevels_up)
! 	{
  		return false;
+ 	}
+ 	else if (IsA(node, Aggref) &&
+ 			(int) ((Aggref *) node)->agglevelsup == context->sublevels_up)
+ 	{
+ 		return check_ungrouped_columns_walker(((Aggref *)node)->orddirectargs, context);
+ 	}
  
  	/*
  	 * If we have any GROUP BY items that are not simple Vars, check to see if
***************
*** 1005,1016 **** build_aggregate_fnexprs(Oid *agg_input_types,
  		args = lappend(args, argp);
  	}
  
! 	*transfnexpr = (Expr *) makeFuncExpr(transfn_oid,
! 										 agg_state_type,
! 										 args,
! 										 InvalidOid,
! 										 agg_input_collation,
! 										 COERCE_EXPLICIT_CALL);
  
  	/* see if we have a final function */
  	if (!OidIsValid(finalfn_oid))
--- 1027,1045 ----
  		args = lappend(args, argp);
  	}
  
! 	if (OidIsValid(transfn_oid))
! 	{
! 		*transfnexpr = (Expr *) makeFuncExpr(transfn_oid,
! 										agg_state_type,
! 										args,
! 										InvalidOid,
! 										agg_input_collation,
! 										COERCE_EXPLICIT_CALL);
! 	}
! 	else
! 	{
! 		transfnexpr = NULL;
! 	}
  
  	/* see if we have a final function */
  	if (!OidIsValid(finalfn_oid))
*** a/src/backend/parser/parse_expr.c
--- b/src/backend/parser/parse_expr.c
***************
*** 464,470 **** transformIndirection(ParseState *pstate, Node *basenode, List *indirection)
  										  list_make1(n),
  										  list_make1(result),
  										  NIL, NULL, false, false, false,
! 										  NULL, true, location);
  			if (newresult == NULL)
  				unknown_attribute(pstate, result, strVal(n), location);
  			result = newresult;
--- 464,470 ----
  										  list_make1(n),
  										  list_make1(result),
  										  NIL, NULL, false, false, false,
! 										  false, NULL, true, location);
  			if (newresult == NULL)
  				unknown_attribute(pstate, result, strVal(n), location);
  			result = newresult;
***************
*** 632,638 **** transformColumnRef(ParseState *pstate, ColumnRef *cref)
  											 list_make1(makeString(colname)),
  											 list_make1(node),
  											 NIL, NULL, false, false, false,
! 											 NULL, true, cref->location);
  				}
  				break;
  			}
--- 632,638 ----
  											 list_make1(makeString(colname)),
  											 list_make1(node),
  											 NIL, NULL, false, false, false,
! 											 false, NULL, true, cref->location);
  				}
  				break;
  			}
***************
*** 677,683 **** transformColumnRef(ParseState *pstate, ColumnRef *cref)
  											 list_make1(makeString(colname)),
  											 list_make1(node),
  											 NIL, NULL, false, false, false,
! 											 NULL, true, cref->location);
  				}
  				break;
  			}
--- 677,683 ----
  											 list_make1(makeString(colname)),
  											 list_make1(node),
  											 NIL, NULL, false, false, false,
! 											 false, NULL, true, cref->location);
  				}
  				break;
  			}
***************
*** 735,741 **** transformColumnRef(ParseState *pstate, ColumnRef *cref)
  											 list_make1(makeString(colname)),
  											 list_make1(node),
  											 NIL, NULL, false, false, false,
! 											 NULL, true, cref->location);
  				}
  				break;
  			}
--- 735,741 ----
  											 list_make1(makeString(colname)),
  											 list_make1(node),
  											 NIL, NULL, false, false, false,
! 											 false, NULL, true, cref->location);
  				}
  				break;
  			}
***************
*** 1248,1255 **** transformFuncCall(ParseState *pstate, FuncCall *fn)
  	targs = NIL;
  	foreach(args, fn->args)
  	{
! 		targs = lappend(targs, transformExprRecurse(pstate,
! 													(Node *) lfirst(args)));
  	}
  
  	/*
--- 1248,1254 ----
  	targs = NIL;
  	foreach(args, fn->args)
  	{
! 		targs = lappend(targs, transformExprRecurse(pstate, (Node *) lfirst(args)));
  	}
  
  	/*
***************
*** 1271,1276 **** transformFuncCall(ParseState *pstate, FuncCall *fn)
--- 1270,1276 ----
  							 fn->agg_star,
  							 fn->agg_distinct,
  							 fn->func_variadic,
+ 							 fn->has_within_group,
  							 fn->over,
  							 false,
  							 fn->location);
*** a/src/backend/parser/parse_func.c
--- b/src/backend/parser/parse_func.c
***************
*** 17,22 ****
--- 17,23 ----
  #include "access/htup_details.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_type.h"
+ #include "catalog/pg_aggregate.h"
  #include "funcapi.h"
  #include "lib/stringinfo.h"
  #include "nodes/makefuncs.h"
***************
*** 27,32 ****
--- 28,34 ----
  #include "parser/parse_relation.h"
  #include "parser/parse_target.h"
  #include "parser/parse_type.h"
+ #include "parser/parse_expr.h"
  #include "utils/builtins.h"
  #include "utils/lsyscache.h"
  #include "utils/syscache.h"
***************
*** 63,69 **** Node *
  ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  				  List *agg_order, Expr *agg_filter,
  				  bool agg_star, bool agg_distinct, bool func_variadic,
! 				  WindowDef *over, bool is_column, int location)
  {
  	Oid			rettype;
  	Oid			funcid;
--- 65,71 ----
  ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  				  List *agg_order, Expr *agg_filter,
  				  bool agg_star, bool agg_distinct, bool func_variadic,
! 				  bool agg_within_group, WindowDef *over, bool is_column, int location)
  {
  	Oid			rettype;
  	Oid			funcid;
***************
*** 81,86 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 83,94 ----
  	int			nvargs;
  	Oid			vatype;
  	FuncDetailCode fdresult;
+ 	HeapTuple	tup;
+ 	Oid		aggfinalfn;
+ 	int		number_of_args;
+ 
+ 	/* Check if the function has WITHIN GROUP as well as distinct. */
+ 	Assert(!(agg_within_group && agg_distinct));
  
  	/*
  	 * Most of the rest of the parser just assumes that functions do not have
***************
*** 163,174 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 171,208 ----
  		}
  	}
  
+ 	if(agg_within_group && argnames)
+ 	{
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_SYNTAX_ERROR),
+ 			errmsg("Named arguments not allowed in WITHIN GROUP")));
+ 	}
+ 
  	if (fargs)
  	{
  		first_arg = linitial(fargs);
  		Assert(first_arg != NULL);
  	}
  
+ 	/* If WITHIN GROUP is present, we need to call transformExpr on each
+ 	 * SortBy node in agg_order, then call exprType and append to
+ 	 * actual_arg_types, in order to get the types of values in
+ 	 * WITHIN BY clause.
+ 	 */
+ 	if(agg_within_group)
+ 	{
+ 		Assert(agg_order != NULL);
+ 
+ 		foreach(l, agg_order)
+ 		{
+ 			SortBy	   *arg = (SortBy *) lfirst(l);
+ 
+ 			arg->node = transformExpr(pstate, arg->node, EXPR_KIND_ORDER_BY);
+ 
+ 			actual_arg_types[nargs++] = exprType(arg->node);
+ 		}
+ 	}
+ 
  	/*
  	 * Check for column projection: if function has one argument, and that
  	 * argument is of complex type, and function name is not qualified, then
***************
*** 247,252 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 281,292 ----
  			errmsg("DISTINCT specified, but %s is not an aggregate function",
  				   NameListToString(funcname)),
  					 parser_errposition(pstate, location)));
+ 		if (agg_within_group)
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 			errmsg("WITHIN GROUP specified, but %s is not an ordered set function",
+ 				   NameListToString(funcname)),
+ 					 parser_errposition(pstate, location)));
  		if (agg_order != NIL)
  			ereport(ERROR,
  					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
***************
*** 266,271 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 306,329 ----
  							NameListToString(funcname)),
  					 parser_errposition(pstate, location)));
  	}
+ 	else if (fdresult == FUNCDETAIL_ORDERED)
+ 	{
+ 		if(!agg_within_group)
+ 		{
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 					 errmsg("Ordered set function specified, but WITHIN GROUP not present"),
+ 					 parser_errposition(pstate, location)));
+ 		}
+ 		
+ 		if(over)
+ 		{
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+ 					 errmsg("OVER clause in ordered set function not supported"),
+ 					 parser_errposition(pstate, location)));
+ 		}
+ 	}
  	else if (!(fdresult == FUNCDETAIL_AGGREGATE ||
  			   fdresult == FUNCDETAIL_WINDOWFUNC))
  	{
***************
*** 351,357 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  											   false);
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, fargs, actual_arg_types, declared_arg_types);
  
  	/*
  	 * If it's a variadic function call, transform the last nvargs arguments
--- 409,417 ----
  											   false);
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, fargs, (fdresult==FUNCDETAIL_ORDERED) ? agg_order : NIL, 
! 				actual_arg_types, 
! 				declared_arg_types);
  
  	/*
  	 * If it's a variadic function call, transform the last nvargs arguments
***************
*** 416,425 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  
  		retval = (Node *) funcexpr;
  	}
! 	else if (fdresult == FUNCDETAIL_AGGREGATE && !over)
  	{
  		/* aggregate function */
  		Aggref	   *aggref = makeNode(Aggref);
  
  		aggref->aggfnoid = funcid;
  		aggref->aggtype = rettype;
--- 476,492 ----
  
  		retval = (Node *) funcexpr;
  	}
! 	else if ((fdresult == FUNCDETAIL_AGGREGATE && !over) || fdresult == FUNCDETAIL_ORDERED)
  	{
  		/* aggregate function */
  		Aggref	   *aggref = makeNode(Aggref);
+ 		if(agg_within_group && fdresult == FUNCDETAIL_AGGREGATE)
+ 		{
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 					 errmsg("%s is not an ordered set function",func_signature_string(funcname, nargs,
+ 											  NIL, actual_arg_types))));
+ 		}
  
  		aggref->aggfnoid = funcid;
  		aggref->aggtype = rettype;
***************
*** 430,435 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 497,522 ----
  		/* agglevelsup will be set by transformAggregateCall */
  		aggref->location = location;
  
+ 		if (fdresult == FUNCDETAIL_ORDERED)
+ 		{
+ 			Form_pg_aggregate classForm;
+ 			tup = SearchSysCache1(AGGFNOID, ObjectIdGetDatum(funcid));
+ 			if (!HeapTupleIsValid(tup)) /* should not happen */
+ 				elog(ERROR, "cache lookup failed for aggregate %u", funcid);
+ 
+ 			classForm = (Form_pg_aggregate) GETSTRUCT(tup);
+ 			aggfinalfn = classForm->aggfinalfn;
+ 			number_of_args = get_func_nargs(aggfinalfn);
+ 			if (number_of_args != list_length(fargs))
+ 			{
+ 				ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 					 errmsg("Number of arguments does not match fargs")));
+ 			}
+ 
+ 			ReleaseSysCache(tup);
+ 		}
+ 
  		/*
  		 * Reject attempt to call a parameterless aggregate without (*)
  		 * syntax.	This is mere pedantry but some folks insisted ...
***************
*** 460,466 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
  					 parser_errposition(pstate, location)));
  
  		/* parse_agg.c does additional aggregate-specific processing */
! 		transformAggregateCall(pstate, aggref, fargs, agg_order, agg_distinct);
  
  		retval = (Node *) aggref;
  	}
--- 547,553 ----
  					 parser_errposition(pstate, location)));
  
  		/* parse_agg.c does additional aggregate-specific processing */
! 		transformAggregateCall(pstate, aggref, fargs, agg_order, agg_distinct, agg_within_group);
  
  		retval = (Node *) aggref;
  	}
***************
*** 469,474 **** ParseFuncOrColumn(ParseState *pstate, List *funcname, List *fargs,
--- 556,569 ----
  		/* window function */
  		WindowFunc *wfunc = makeNode(WindowFunc);
  
+ 		if(agg_within_group)
+ 		{
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_WRONG_OBJECT_TYPE),
+ 					 errmsg("WITHIN GROUP not allowed in window functions"),
+ 					 parser_errposition(pstate, location)));
+ 		}
+ 
  		/*
  		 * True window functions must be called with a window definition.
  		 */
***************
*** 1264,1269 **** func_get_detail(List *funcname,
--- 1359,1366 ----
  
  		ftup = SearchSysCache1(PROCOID,
  							   ObjectIdGetDatum(best_candidate->oid));
+ 
+ 		
  		if (!HeapTupleIsValid(ftup))	/* should not happen */
  			elog(ERROR, "cache lookup failed for function %u",
  				 best_candidate->oid);
***************
*** 1341,1347 **** func_get_detail(List *funcname,
  			}
  		}
  		if (pform->proisagg)
! 			result = FUNCDETAIL_AGGREGATE;
  		else if (pform->proiswindow)
  			result = FUNCDETAIL_WINDOWFUNC;
  		else
--- 1438,1460 ----
  			}
  		}
  		if (pform->proisagg)
! 		{
! 			Form_pg_aggregate pfagg;
! 			HeapTuple	ftup_agg;
! 
! 			ftup_agg = SearchSysCache1(AGGFNOID, ObjectIdGetDatum(best_candidate->oid));
! 			pfagg = (Form_pg_aggregate) GETSTRUCT(ftup_agg);
! 			if (pfagg->aggisordsetfunc)
! 			{
! 				result = FUNCDETAIL_ORDERED;
! 			}
! 			else
! 			{
! 				result = FUNCDETAIL_AGGREGATE;
! 			}
! 
! 			ReleaseSysCache(ftup_agg);
! 		}
  		else if (pform->proiswindow)
  			result = FUNCDETAIL_WINDOWFUNC;
  		else
***************
*** 1370,1379 **** func_get_detail(List *funcname,
--- 1483,1494 ----
  void
  make_fn_arguments(ParseState *pstate,
  				  List *fargs,
+ 				  List *agg_order,
  				  Oid *actual_arg_types,
  				  Oid *declared_arg_types)
  {
  	ListCell   *current_fargs;
+ 	ListCell   *current_aoargs;
  	int			i = 0;
  
  	foreach(current_fargs, fargs)
***************
*** 1414,1419 **** make_fn_arguments(ParseState *pstate,
--- 1529,1553 ----
  		}
  		i++;
  	}
+ 
+ 	foreach(current_aoargs, agg_order)
+ 	{
+ 		if (actual_arg_types[i] != declared_arg_types[i])
+ 		{
+ 			SortBy	   *node = (SortBy *) lfirst(current_aoargs);
+ 			SortBy     *temp = NULL;
+ 
+ 			temp = coerce_type(pstate,
+ 							node->node,
+ 							actual_arg_types[i],
+ 							declared_arg_types[i], -1,
+ 							COERCION_IMPLICIT,
+ 							COERCE_IMPLICIT_CAST,
+ 							-1);
+ 			node->node = temp;
+ 		}
+ 		i++;
+ 	}
  }
  
  /*
*** a/src/backend/parser/parse_oper.c
--- b/src/backend/parser/parse_oper.c
***************
*** 823,829 **** make_op(ParseState *pstate, List *opname, Node *ltree, Node *rtree,
  											   false);
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, args, actual_arg_types, declared_arg_types);
  
  	/* and build the expression node */
  	result = makeNode(OpExpr);
--- 823,829 ----
  											   false);
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, args, NULL, actual_arg_types, declared_arg_types);
  
  	/* and build the expression node */
  	result = makeNode(OpExpr);
***************
*** 953,959 **** make_scalar_array_op(ParseState *pstate, List *opname,
  	declared_arg_types[1] = res_atypeId;
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, args, actual_arg_types, declared_arg_types);
  
  	/* and build the expression node */
  	result = makeNode(ScalarArrayOpExpr);
--- 953,959 ----
  	declared_arg_types[1] = res_atypeId;
  
  	/* perform the necessary typecasting of arguments */
! 	make_fn_arguments(pstate, args, NULL, actual_arg_types, declared_arg_types);
  
  	/* and build the expression node */
  	result = makeNode(ScalarArrayOpExpr);
*** a/src/backend/utils/adt/Makefile
--- b/src/backend/utils/adt/Makefile
***************
*** 25,31 **** OBJS = acl.o arrayfuncs.o array_selfuncs.o array_typanalyze.o \
  	rowtypes.o regexp.o regproc.o ruleutils.o selfuncs.o \
  	tid.o timestamp.o varbit.o varchar.o varlena.o version.o xid.o \
  	network.o mac.o inet_cidr_ntop.o inet_net_pton.o \
! 	ri_triggers.o pg_lzcompress.o pg_locale.o formatting.o \
  	ascii.o quote.o pgstatfuncs.o encode.o dbsize.o genfile.o trigfuncs.o \
  	tsginidx.o tsgistidx.o tsquery.o tsquery_cleanup.o tsquery_gist.o \
  	tsquery_op.o tsquery_rewrite.o tsquery_util.o tsrank.o \
--- 25,31 ----
  	rowtypes.o regexp.o regproc.o ruleutils.o selfuncs.o \
  	tid.o timestamp.o varbit.o varchar.o varlena.o version.o xid.o \
  	network.o mac.o inet_cidr_ntop.o inet_net_pton.o \
! 	inversedistribution.o ri_triggers.o pg_lzcompress.o pg_locale.o formatting.o \
  	ascii.o quote.o pgstatfuncs.o encode.o dbsize.o genfile.o trigfuncs.o \
  	tsginidx.o tsgistidx.o tsquery.o tsquery_cleanup.o tsquery_gist.o \
  	tsquery_op.o tsquery_rewrite.o tsquery_util.o tsrank.o \
*** /dev/null
--- b/src/backend/utils/adt/inversedistribution.c
***************
*** 0 ****
--- 1,237 ----
+ /*-------------------------------------------------------------------------
+  *
+  * inversedistribution.c
+  *	  Inverse distribution functions.
+  *
+  * Portions Copyright (c) 1996-2013, PostgreSQL Global Development Group
+  * Portions Copyright (c) 1994, Regents of the University of California
+  *
+  *
+  * IDENTIFICATION
+  *	  src/backend/utils/adt/inversedistribution.c
+  *
+  *-------------------------------------------------------------------------
+  */
+ #include "postgres.h"
+ #include "fmgr.h"
+ #include <string.h>
+ #include <math.h>
+ 
+ #include "utils/tuplesort.h"
+ #include "catalog/pg_type.h"
+ #include "utils/datetime.h"
+ 
+ /*
+  * percentile_disc(float8)  - discrete (nearest) percentile
+  */
+ 
+ Datum percentile_disc_final(PG_FUNCTION_ARGS);
+ 
+ Datum
+ percentile_disc_final(PG_FUNCTION_ARGS)
+ {
+ 	float8 percentile = PG_GETARG_FLOAT8(0);
+ 	int64 rowcount = AggSetGetRowCount(fcinfo);
+ 	Tuplesortstate *sorter;
+ 	Oid datumtype;
+ 	Datum val;
+ 	bool isnull;
+ 	int64 skiprows;
+ 
+ 	AggSetGetSortInfo(fcinfo, &sorter, NULL, NULL, &datumtype);
+ 
+ 	Assert(datumtype == FLOAT8OID);
+ 
+ 	if (percentile < 0 || percentile > 1)
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_NUMERIC_VALUE_OUT_OF_RANGE),
+ 				 errmsg("percentile value %g is not between 0 and 1", percentile)));
+ 
+ 	if (rowcount < 1)
+ 		PG_RETURN_NULL();
+ 
+ 	tuplesort_performsort(sorter);
+ 
+ 	/*
+ 	 * We need the smallest K such that (K/N) >= percentile. K starts at 1.
+ 	 * Therefore K >= N*percentile
+ 	 * Therefore K = ceil(N*percentile)
+ 	 * So we skip K-1 rows (if K>0) and return the next row fetched.
+ 	 */
+ 
+ 	skiprows = (int64) ceil(percentile * rowcount);
+ 	Assert(skiprows <= rowcount);
+ 
+ 	while (--skiprows > 0)
+ 		if (!tuplesort_getdatum(sorter, true, NULL, NULL))
+ 			elog(ERROR,"missing row in percentile_disc");
+ 
+ 	if (!tuplesort_getdatum(sorter, true, &val, &isnull))
+ 		elog(ERROR,"missing row in percentile_disc");
+ 
+ 	/* if float8 is by-ref, "val" already points to palloced space in
+ 	 * our memory context. No need to do more.
+ 	 */
+ 
+ 	if (isnull)
+ 		PG_RETURN_NULL();
+ 	else
+ 		PG_RETURN_DATUM(val);
+ }
+ 
+ 
+ 
+ /*
+  * percentile_cont(float8)  - continuous (nearest) percentile
+  */
+ 
+ Datum percentile_cont_final(PG_FUNCTION_ARGS);
+ 
+ Datum
+ percentile_cont_final(PG_FUNCTION_ARGS)
+ {
+ 	float8 percentile = PG_GETARG_FLOAT8(0);
+ 	int64 rowcount = AggSetGetRowCount(fcinfo);
+ 	Tuplesortstate *sorter;
+ 	Oid datumtype;
+ 	Datum val;
+ 	Datum first_row;
+ 	Datum second_row;
+ 	float8 first_row_val;
+ 	float8 second_row_val;
+ 	float8 proportion;
+ 	bool isnull;
+ 	int64 skiprows;
+ 	int64 lower_row = 0;
+ 	int64 higher_row = 0;
+ 
+ 	AggSetGetSortInfo(fcinfo, &sorter, NULL, NULL, &datumtype);
+ 
+ 	Assert(datumtype == FLOAT8OID);
+ 
+ 	if (percentile < 0 || percentile > 1)
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_NUMERIC_VALUE_OUT_OF_RANGE),
+ 				 errmsg("percentile value %g is not between 0 and 1", percentile)));
+ 
+ 	if (rowcount < 1)
+ 		PG_RETURN_NULL();
+ 
+ 	tuplesort_performsort(sorter);
+ 
+ 	lower_row = floor(percentile * (rowcount -1));
+ 	higher_row = ceil(percentile * (rowcount -1));
+ 
+ 	Assert(lower_row < rowcount);
+ 
+ 	for (skiprows = lower_row; skiprows > 0; --skiprows)
+ 		if (!tuplesort_getdatum(sorter, true, NULL, NULL))
+ 			elog(ERROR,"missing row in percentile_cont");
+ 
+ 	if (!tuplesort_getdatum(sorter, true, &first_row, &isnull))
+ 			elog(ERROR,"missing row in percentile_cont");
+ 
+ 	if (lower_row == higher_row)
+ 	{
+ 
+ 		val = first_row;
+ 	}
+ 	else
+ 	{
+ 		if (!tuplesort_getdatum(sorter, true, &second_row, &isnull))
+ 			elog(ERROR,"missing row in percentile_cont");
+ 
+ 		if (isnull)
+ 			PG_RETURN_NULL();
+ 
+ 		proportion = (percentile * (rowcount-1)) - lower_row;
+ 		first_row_val = DatumGetFloat8(first_row);
+ 		second_row_val = DatumGetFloat8(second_row); 
+ 		val = Float8GetDatum(first_row_val + (proportion *(second_row_val - first_row_val)));
+ 	}
+ 
+ 	if (isnull)
+ 		PG_RETURN_NULL();
+ 	else
+ 		PG_RETURN_DATUM(val);
+ }
+ 
+ /*
+  * percentile_interval_cont(Interval)  - continuous (nearest) percentile for Interval
+  */
+ 
+ Datum percentile_interval_cont_final(PG_FUNCTION_ARGS);
+ 
+ Datum
+ percentile_interval_cont_final(PG_FUNCTION_ARGS)
+ {
+ 	float8 percentile = PG_GETARG_FLOAT8(0);
+ 	int64 rowcount = AggSetGetRowCount(fcinfo);
+ 	Tuplesortstate *sorter;
+ 	Oid datumtype;
+ 	Datum val;
+ 	Datum first_row;
+ 	Datum second_row;
+ 	float8 proportion;
+ 	bool isnull;
+ 	int64 skiprows;
+ 	int64 lower_row = 0;
+ 	int64 higher_row = 0;
+ 	Datum diff_result;
+ 	Datum mul_result;
+ 	Datum add_result;
+ 
+ 	AggSetGetSortInfo(fcinfo, &sorter, NULL, NULL, &datumtype);
+ 
+ 	Assert(datumtype == INTERVALOID);
+ 
+ 	if (percentile < 0 || percentile > 1)
+ 		ereport(ERROR,
+ 				(errcode(ERRCODE_NUMERIC_VALUE_OUT_OF_RANGE),
+ 				 errmsg("percentile value %g is not between 0 and 1", percentile)));
+ 
+ 	if (rowcount < 1)
+ 		PG_RETURN_NULL();
+ 
+ 	tuplesort_performsort(sorter);
+ 
+ 	lower_row = floor(percentile * (rowcount -1));
+ 	higher_row = ceil(percentile * (rowcount -1));
+ 
+ 	Assert(lower_row < rowcount);
+ 
+ 	for (skiprows = lower_row; skiprows > 0; --skiprows)
+ 		if (!tuplesort_getdatum(sorter, true, NULL, NULL))
+ 			elog(ERROR,"missing row in percentile_cont");
+ 
+ 	if (!tuplesort_getdatum(sorter, true, &first_row, &isnull))
+ 			elog(ERROR,"missing row in percentile_cont");
+ 
+ 	if (lower_row == higher_row)
+ 	{
+ 
+ 		val = first_row;
+ 	}
+ 	else
+ 	{
+ 		if (!tuplesort_getdatum(sorter, true, &second_row, &isnull))
+ 			elog(ERROR,"missing row in percentile_cont");
+ 
+ 		if (isnull)
+ 			PG_RETURN_NULL();
+ 
+ 		proportion = (percentile * (rowcount-1)) - lower_row;
+ 
+ 		diff_result = DirectFunctionCall2(interval_mi, second_row, first_row);
+ 		mul_result = DirectFunctionCall2(interval_mul, diff_result, Float8GetDatumFast(proportion));
+ 		add_result = DirectFunctionCall2(interval_pl, mul_result, first_row);
+ 		val = add_result;
+ 	}
+ 
+ 	if (isnull)
+ 		PG_RETURN_NULL();
+ 	else
+ 		PG_RETURN_DATUM(val);
+ }
+ 
+ 
*** a/src/backend/utils/adt/ruleutils.c
--- b/src/backend/utils/adt/ruleutils.c
***************
*** 402,407 **** static char *generate_function_name(Oid funcid, int nargs,
--- 402,409 ----
  static char *generate_operator_name(Oid operid, Oid arg1, Oid arg2);
  static text *string_to_text(char *str);
  static char *flatten_reloptions(Oid relid);
+ static void get_aggstd_expr(Aggref *aggref, deparse_context *context);
+ static void get_ordset_expr(Aggref *aggref, deparse_context *context);
  
  #define only_marker(rte)  ((rte)->inh ? "" : "ONLY ")
  
***************
*** 7384,7389 **** static void
--- 7386,7468 ----
  get_agg_expr(Aggref *aggref, deparse_context *context)
  {
  	StringInfo	buf = context->buf;
+ 
+ 	if (aggref->isordset)
+ 	{
+ 		get_ordset_expr(aggref, context);
+ 	}
+ 	else
+ 	{
+ 		get_aggstd_expr(aggref, context);
+ 	}
+ 
+ 	if (aggref->aggfilter != NULL)
+ 	{
+ 		appendStringInfoString(buf, ") FILTER (WHERE ");
+ 		get_rule_expr((Node *)aggref->aggfilter, context, false);
+ 	}
+ 
+ 	appendStringInfoString(buf, ")");
+ }
+ 
+ static void
+ get_ordset_expr(Aggref *aggref, deparse_context *context)
+ {
+ 	StringInfo	buf = context->buf;
+ 	Oid			argtypes[FUNC_MAX_ARGS];
+ 	List	   *arglist;
+ 	int			nargs;
+ 	ListCell   *l;
+ 
+ 	/* Extract the regular arguments, ignoring resjunk stuff for the moment */
+ 	arglist = NIL;
+ 	nargs = 0;
+ 
+ 	foreach(l, aggref->orddirectargs)
+ 	{
+ 		Node	   *arg = (Node *) lfirst(l);
+ 
+ 		Assert(!IsA(arg, NamedArgExpr));
+ 		if (nargs >= FUNC_MAX_ARGS)		/* paranoia */
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_TOO_MANY_ARGUMENTS),
+ 					 errmsg("too many arguments")));
+ 		argtypes[nargs] = exprType(arg);
+ 		nargs++;
+ 	}
+ 
+ 	/* For direct arguments in case of ordered set functions */
+ 	foreach(l, aggref->args)
+ 	{
+ 		TargetEntry *tle = (TargetEntry *) lfirst(l);
+ 		Node	   *arg = (Node *) tle->expr;
+ 
+ 		Assert(!IsA(arg, NamedArgExpr));
+ 		if (tle->resjunk)
+ 			continue;
+ 		if (nargs >= FUNC_MAX_ARGS)		/* paranoia */
+ 			ereport(ERROR,
+ 					(errcode(ERRCODE_TOO_MANY_ARGUMENTS),
+ 					 errmsg("too many arguments")));
+ 		argtypes[nargs] = exprType(arg);
+ 		arglist = lappend(arglist, arg);
+ 		nargs++;
+ 	}
+ 
+ 	appendStringInfo(buf, "%s(",
+ 					 generate_function_name(aggref->aggfnoid, nargs,
+ 											NIL, argtypes,
+ 											false, NULL));
+ 
+ 	get_rule_expr((Node *)aggref->orddirectargs, context, true);
+ 	appendStringInfoString(buf, ") WITHIN GROUP (ORDER BY ");
+ 	get_rule_orderby(aggref->aggorder, aggref->args, false, context);
+ 	
+ }
+ static void
+ get_aggstd_expr(Aggref *aggref, deparse_context *context)
+ {
+ 	StringInfo	buf = context->buf;
  	Oid			argtypes[FUNC_MAX_ARGS];
  	List	   *arglist;
  	int			nargs;
***************
*** 7424,7437 **** get_agg_expr(Aggref *aggref, deparse_context *context)
  		appendStringInfoString(buf, " ORDER BY ");
  		get_rule_orderby(aggref->aggorder, aggref->args, false, context);
  	}
- 
- 	if (aggref->aggfilter != NULL)
- 	{
- 		appendStringInfoString(buf, ") FILTER (WHERE ");
- 		get_rule_expr((Node *) aggref->aggfilter, context, false);
- 	}
- 
- 	appendStringInfoChar(buf, ')');
  }
  
  /*
--- 7503,7508 ----
***************
*** 7472,7478 **** get_windowfunc_expr(WindowFunc *wfunc, deparse_context *context)
  	if (wfunc->aggfilter != NULL)
  	{
  		appendStringInfoString(buf, ") FILTER (WHERE ");
! 		get_rule_expr((Node *) wfunc->aggfilter, context, false);
  	}
  
  	appendStringInfoString(buf, ") OVER ");
--- 7543,7549 ----
  	if (wfunc->aggfilter != NULL)
  	{
  		appendStringInfoString(buf, ") FILTER (WHERE ");
! 		get_rule_expr((Node *)wfunc->aggfilter, context, false);
  	}
  
  	appendStringInfoString(buf, ") OVER ");
